class ApplicationController < ActionController::Base
  protect_from_forgery
  before_filter :bf
  
  def bf
    if Admin.count.to_i == 0 or License.count.to_i == 0
      if params[:controller] == 'system' and params[:action] == 'start'
      else
        redirect_to :controller => '/system', :action => 'start'
      end
    else
      if user_signed_in?
        @user = current_user
        @author = @user.author
        @artist = if @author and @author.artist?
          @author.artist
        else
          Artist.new author_id: @author.id, email: @user.email, name: @author.name
        end
      end
    end
  end
  
  def authenticate_artist
    if @author.artist?
      true
    else
      respond_to do |format|
        format.html { redirect_to main_app.new_artist_path, :status => :found }
        format.js { render "artists/new" }
        format.json { 
          raise ActiveRecord::Forbidden
        }
      end
      false
    end
  end
  
=begin
  rescue_from ActiveRecord::RecordNotFound, :with => :render_404

  private
  def render_404(exception = nil)
    if exception
        logger.info "Rendering 404: #{exception.message}"
    end
    respond_to do |format|
          format.html { 
    render :file => "#{Rails.root}/public/404.html", :status => 404, :layout => false
}
          format.json { 
    render :text => "404 found", :status => 404
}
  end
  end
=end  
end
