class Author < ActiveRecord::Base
  has_one :artist
  belongs_to :user
  
  validates :name, :length => {:maximum => 30}
  
  before_save do |r|
    r.name = 'no name' if r.name.blank?
  end
  
  def artist?
    Artist.find_by_author(self) != nil
  end
  
  def step2 n
    self.name = n
    self.save
  end
  
  def self.default_page_size
    25
  end
  
  def self.max_page_size
    100
  end
  
  def self.page prm = nil
    page = prm.to_i
    page = 1 if page < 1
    page
  end
  
  def self.page_size prm = self.default_page_size
    page_size = prm.to_i
    page_size = self.max_page_size if page_size > self.max_page_size
    page_size = self.default_page_size if page_size < 1
    page_size
  end
  
  def self.list opt = {}, page = 1, page_size = self.default_page_size
    opt.merge!(self.list_opt) unless opt[:include]
    opt.merge!({:order => 'updated_at desc', :limit => page_size, :offset => (page -1) * page_size})
    Author.find(:all, opt)
  end
  
  def self.list_opt
    {:include => :artist}
  end
  
  def self.list_json_opt
    {:include => :artist}
  end
  
  def self.default_comic_page_size
    30
  end
  
  def self.comic_max_page_size
    200
  end
  
  def self.comic_page_size prm = self.default_comic_page_size
    page_size = prm.to_i
    page_size = self.comic_max_page_size if page_size > self.comic_max_page_size
    page_size = self.default_comic_page_size if page_size < 1
    page_size
  end
  
  def self.default_story_page_size
    30
  end
  
  def self.story_max_page_size
    200
  end
  
  def self.story_page_size prm = self.default_story_page_size
    page_size = prm.to_i
    page_size = self.story_max_page_size if page_size > self.story_max_page_size
    page_size = self.default_story_page_size if page_size < 1
    page_size
  end
  
  def self.default_panel_page_size
    30
  end
  
  def self.panel_max_page_size
    200
  end
  
  def self.panel_page_size prm = self.default_panel_page_size
    page_size = prm.to_i
    page_size = self.panel_max_page_size if page_size > self.panel_max_page_size
    page_size = self.default_panel_page_size if page_size < 1
    page_size
  end
  
  def self.default_panel_picture_page_size
    30
  end
  
  def self.panel_picture_max_page_size
    200
  end
  
  def self.panel_picture_page_size prm = self.default_panel_picture_page_size
    page_size = prm.to_i
    page_size = self.panel_picture_max_page_size if page_size > self.panel_picture_max_page_size
    page_size = self.default_panel_picture_page_size if page_size < 1
    page_size
  end
  
  def self.default_ground_picture_page_size
    30
  end
  
  def self.ground_picture_max_page_size
    200
  end
  
  def self.ground_picture_page_size prm = self.default_ground_picture_page_size
    page_size = prm.to_i
    page_size = self.ground_picture_max_page_size if page_size > self.ground_picture_max_page_size
    page_size = self.default_ground_picture_page_size if page_size < 1
    page_size
  end
  
  def self.default_ground_color_page_size
    30
  end
  
  def self.ground_color_max_page_size
    200
  end
  
  def self.ground_color_page_size prm = self.default_ground_color_page_size
    page_size = prm.to_i
    page_size = self.ground_color_max_page_size if page_size > self.ground_color_max_page_size
    page_size = self.default_ground_color_page_size if page_size < 1
    page_size
  end
  
  def self.default_panel_color_page_size
    30
  end
  
  def self.panel_color_max_page_size
    200
  end
  
  def self.panel_color_page_size prm = self.default_panel_color_page_size
    page_size = prm.to_i
    page_size = self.panel_color_max_page_size if page_size > self.panel_color_max_page_size
    page_size = self.default_panel_color_page_size if page_size < 1
    page_size
  end
  
  def self.show aid, opt = {}
    a = Author.find(aid, :include => self.show_include_opt(opt))
#    raise ActiveRecord::Forbidden unless c.visible?(au)
    a
  end
  
  def self.show_include_opt opt = {}
    res = [:artist]
    res.push(opt[:include]) if opt[:include]
    res
  end
  
  def self.show_json_include_opt
    {:include => :artist}
  end
  
  def self.visible_count
    Author.count
  end
  
end
