#ライセンスグループ
class LicenseGroup < ActiveRecord::Base
  has_many :licenses
  
  validates :name, :presence => true, :length => {:maximum => 50}, :uniqueness => true
  validates :classname, :presence => true, :length => {:maximum => 50}
  validates :caption, :presence => true, :length => {:maximum => 30}
  validates :url, :presence => true, :length => {:maximum => 200}, :url => true
  
  def self.store name, attr
    #ライセンスデータがあるとライセンスグループのデータ生成で邪魔するので移しておく
    lattr = attr["licenses_attributes"]
    attr.delete "licenses_attributes"
    #ライセンスグループを先に保存してidを決める
    r = LicenseGroup.modify_object name, attr
    r.save
    #取っておいたライセンスデータとidでライセンス作成
    if (c = License.stores(lattr, r.id)) > 0
      r.errors.add :base, 'licenses can not create'
    end
    r
  end
  
  def self.import filename
    LicenseGroup.import_file(filename) {|name, attr| LicenseGroup.store(name, attr)}
  end
  
  def self.list opt = {}
    opt.merge!(self.list_opt) unless opt[:include]
    opt.merge!({:order => 'license_groups.name asc'})
    LicenseGroup.find(:all, opt)
  end
  
  def self.list_opt
    {:include => {:licenses => {}}}
  end
  
  def self.list_json_opt
    {:include => {:licenses => {}}}
  end
  
  def self.show rid, opt = {}
    r = LicenseGroup.find(rid, :include => self.show_include_opt(opt))
#    raise ActiveRecord::Forbidden unless c.visible?(au)
    r
  end
  
  def self.show_include_opt opt = {}
    res = {:licenses => {}}
    res.push(opt[:include]) if opt[:include]
    res
  end
  
  def self.show_json_include_opt
    {:include => {:licenses => {}}}
  end
  
  def self.disp_import_error r
    if r == false
      puts "json file error. file does not exist or broken"
    else
      unless r.empty?
        r.each do |lg|
          put lg.errors.full_messages
        end
      end
    end
  end
end
