FactoryGirl.define do
  factory :admin, :class => Admin do |admin|
    admin.sequence(:email) { |n| "admin#{n}@gmail.com"}
    admin.password "admin0100"
    admin.password_confirmation "admin0100"
    admin.approve 1
  end

  factory :user_yas, :class => User do |user|
    user.sequence(:email) { |n| "hoge#{n}@gmail.com"}
    user.password "user0100"
    user.password_confirmation "user0100"
  #  user.author FactoryGirl.create(:author_yas)
  end

  factory :author, :class => Author do |author|
    author.name nil
    author.sequence(:user_id) { |n| n}
  end

  factory :author_yas, :class => Author do |author|
    author.name 'yassan'
    author.sequence(:user_id) { |n| n}
  #  author.association :user_yas
  #  author.artist FactoryGirl.create(:artist_yas)
  end

  factory :artist, :class => Artist do |artist|
    artist.sequence(:email) { |n| "hoge#{n}@gmail.com"}
    artist.name 'art'
  #  artist.association :author_yas
  end

  factory :artist_yas, :class => Artist do |artist|
    artist.sequence(:email) { |n| "hoge#{n}@gmail.com"}
    artist.name 'yas'
  #  artist.association :author_yas
  end

  factory :license_group, :class => LicenseGroup do |license_group|
    license_group.name 'pettan_public_01'
    license_group.classname 'PettanPublicLicense'
    license_group.caption 'pettan public 0.1'
    license_group.url 'http://test.lc/'
  end

  factory :license, :class => License do |license|
    license.license_group_id 1
    license.name 'peta2.5'
    license.caption 'flag'
    license.url 'http://test.lc/'
    license.system_picture_id 1
  end

  factory :color, :class => Color do |color|
    color.name 'black'
    color.code 0
    color.t 0
  end

  factory :comic, :class => Comic do |comic|
    comic.title "comic"
    comic.visible 3
  end

  factory :original_picture, :class => OriginalPicture do |op|
    op.ext 'png'
    op.width 222
    op.height 111
    op.filesize 100000
    op.artist_id 1
    op.md5 'op8f6bcd4621d373cade4e832627b4f6'
  end

  factory :oplg, :class => OriginalPictureLicenseGroup do |oplg|
    oplg.original_picture_id 1
    oplg.license_group_id 1
  end

  factory :resource_picture, :class => ResourcePicture do |rp|
    rp.ext 'png'
    rp.width 222
    rp.height 111
    rp.filesize 100000
    rp.md5 'rp8f6bcd4621d373cade4e832627b4f6'
    rp.artist_id 1
    rp.license_id 1
    rp.classname 'StandardLicense'
    rp.original_picture_id 1
  end

  factory :picture, :class => Picture do |p|
    p.original_picture_id 1
    p.revision 1
    p.ext 'png'
    p.width 222
    p.height 111
    p.filesize 100000
    p.md5 'ap8f6bcd4621d373cade4e832627b4f6'
    p.artist_id 1
    p.license_id 1
    p.artist_name 'no name'
    p.classname 'StandardLicense'
    p.credit ''
    p.settings ''
  end

  factory :system_picture, :class => SystemPicture do |sp|
    sp.ext 'png'
    sp.width 222
    sp.height 111
    sp.filesize 100000
    sp.md5 '098f6bcd4621d373cade4e832627b4f6'
  end

  factory :speech_balloon_template, :class => SpeechBalloonTemplate do |sbt|
    sbt.name 'Plain@pettanr.com'
    sbt.classname 'Plain'
    sbt.caption 'normal fuki'
    sbt.t 0
    sbt.settings '{}'
  end

  factory :speech_balloon, :class => SpeechBalloon do |sb|
    sb.panel_id 1
    sb.speech_balloon_template_id 1
    sb.classname 'Plain'
    sb.z 1
    sb.t 0
    sb.settings '{}'
  end

  factory :balloon, :class => Balloon do |balloon|
    balloon.speech_balloon_id 1
    balloon.system_picture_id 1 
    balloon.x 100
    balloon.y 200
    balloon.width 222 
    balloon.height 333 
    balloon.caption 'test pict'
    balloon.settings nil
  end

  factory :speech, :class => Speech do |speech|
    speech.speech_balloon_id 1
    speech.content 'test'
    speech.x 10
    speech.y 100
    speech.width 200
    speech.height 190
    speech.settings nil
  end

  factory :panel_picture, :class => PanelPicture do |pp|
    pp.panel_id 1
    pp.picture_id 1
    pp.link ''
    pp.x 111
    pp.y 200
    pp.z 1
    pp.t 0
    pp.width 100
    pp.height 300
  end

  factory :panel_color, :class => PanelColor do |pc|
    pc.panel_id 1
    pc.z 1
    pc.code 1
  end

  factory :ground_color, :class => GroundColor do |gc|
    gc.panel_id 1
    gc.color_id 1
    gc.z 1
  end

  factory :ground_picture, :class => GroundPicture do |gp|
    gp.panel_id 1
    gp.picture_id 1
    gp.z 1
  end

  factory :panel, :class => Panel do |panel|
    panel.border 1
    panel.x nil
    panel.y nil
    panel.z nil
    panel.width 100
    panel.height 300
    panel.publish 1
    panel.author_id 1
  end

  factory :story, :class => Story do |story|
    story.comic_id 1
    story.panel_id 1
    story.author_id 1
    story.t 0
  end
end
